using System;
using System.Numerics;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            int[,] x;
            x = new int[100, 100];
            int[] pom;
            pom = new int[1000];
            int t;
            t = int.Parse(Console.ReadLine());
            int n, i, j, br=0, pbr=0, h;
            for(i=0; i<t; i++)
            {
                n = int.Parse(Console.ReadLine());
                for(j=0; j<n; j++)
                {
                    var ab = Console.ReadLine().Split();
                    for(h=0; h<n; h++)
                    {
                        x[j, h] = int.Parse(ab[h]);
                    }
                }
                for(j=0; j<n; j++)
                {
                    if(x[0, j]==x[1, n-1]*(-1))
                    {
                        br++;
                    }
                }
                if(br==n)
                {
                    pom[pbr] = 1;
                    pbr++;
                }
                else
                {
                    pom[pbr] = 0;
                    pbr++;
                }
            }
            for(i=0; i<t; i++)
            {
                if(pom[i]==1)
                {
                    Console.WriteLine("DA");
                }
                else
                {
                    Console.WriteLine("NE");
                }
            }
        }
    }
}